import { IEncodeFeature, ILayerConfig, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel, { styleColor, styleOffset, styleSingle } from '../../core/BaseModel';
interface IPointLayerStyleOptions {
    opacity: styleSingle;
    offsets: styleOffset;
    blend: string;
    strokeOpacity: styleSingle;
    strokeWidth: styleSingle;
    stroke: styleColor;
}
export declare function PointTriangulation(feature: IEncodeFeature): {
    vertices: number[];
    indices: number[];
    size: number;
};
export default class SimplePointModel extends BaseModel {
    getDefaultStyle(): Partial<IPointLayerStyleOptions & ILayerConfig>;
    getUninforms(): IModelUniform;
    initModels(): IModel[];
    buildModels(): IModel[];
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private defaultStyleOptions;
}
export {};
