import BaseLayer from '../core/BaseLayer';
import { WindModelType } from './models';
interface IWindLayerStyleOptions {
    uMin?: number;
    uMax?: number;
    vMin?: number;
    vMax?: number;
    fadeOpacity?: number;
    speedFactor?: number;
    dropRate?: number;
    dropRateBump?: number;
    opacity?: number;
    numParticles?: number;
    rampColors?: {
        [key: number]: string;
    };
    sizeScale?: number;
}
export default class WindLayer extends BaseLayer<IWindLayerStyleOptions> {
    type: string;
    buildModels(): void;
    rebuildModels(): void;
    renderModels(): this;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {};
    protected getModelType(): WindModelType;
}
export {};
